Opened 7 years ago

Closed 7 years ago

#17329 closed defect (fixed)

Handle errors in PARI -> CDF conversion

Reported by: was Owned by:
Priority: critical Milestone: sage-6.4
Component: basic arithmetic Keywords:
Cc: pbruin Merged in:
Authors: Jeroen Demeyer Reviewers: Peter Bruin
Report Upstream: N/A Work issues:
Branch: ff6ddb1 (Commits, GitHub, GitLab) Commit: ff6ddb1feb1d8760ef246ec6e20043911800d402
Dependencies: Stopgaps:

Status badges

Description (last modified by jdemeyer)

sage: CDF(pari(1e1000))
sig_error() without sig_on()
------------------------------------------------------------------------
Unhandled SIGABRT: An abort() occurred in Sage.
This probably occurred because a *compiled* component of Sage has a bug
in it and is not properly wrapped with sig_on(), sig_off().
Sage will now terminate.
------------------------------------------------------------------------
./sage: line 134:  7790 Aborted                 "$SAGE_ROOT/src/bin/sage" "$@"

Change History (9)

comment:1 Changed 7 years ago by was

This was found by Austin Tran, who reported

f(z)=zeta(z^2)
complex_plot(f,(-10,10),(-10,10),axes=False,figsize=[10,10],plot_points=1000)

which workes fine, but the same expression with zeta(z3) instead returned the given error. In particular,

f(z)=zeta(z^3)
complex_plot(f,(-10,10),(-10,10),axes=False,figsize=[10,10],plot_points=1000)

gives an error. I tried doing this:

m=0
def f(z):
    global m
    m = z
    return zeta(z^3)

complex_plot(f,(-10,10),(-10,10),axes=False,figsize=[3,3],plot_points=100)

and found that the problem was caused when z = 0.505050505051 - 10.0*I. I then tried explicitly computing zeta(z3) and got the core dump.

Worksheet: https://cloud.sagemath.com/projects/4a5f0542-5873-4eed-a85c-a18c706e8bcd/files/support/2014-11-12-complex-plot.sagews

Last edited 7 years ago by was (previous) (diff)

comment:2 Changed 7 years ago by was

Workaround:

def f(z):
    return zeta(CC(z)^3)

complex_plot(f,(-10,10),(-10,10),axes=False,figsize=[3,3],plot_points=100)

comment:3 Changed 7 years ago by jdemeyer

  • Component changed from number theory to basic arithmetic
  • Description modified (diff)
  • Summary changed from sage-6.4.rc1 (and earlier) crashes when evaluating zeta(CDF(-151.386325246 + 992.34771962*I)) to Handle overflow in PARI -> CDF conversion

comment:4 Changed 7 years ago by jdemeyer

  • Branch set to u/jdemeyer/ticket/17329
  • Created changed from 11/12/14 21:53:44 to 11/12/14 21:53:44
  • Modified changed from 11/13/14 17:08:34 to 11/13/14 17:08:34

comment:5 Changed 7 years ago by jdemeyer

  • Authors set to Jeroen Demeyer
  • Commit set to ff6ddb1feb1d8760ef246ec6e20043911800d402
  • Status changed from new to needs_review

New commits:

ff6ddb1Handle errors in PARI -> CDF conversion

comment:6 Changed 7 years ago by jdemeyer

  • Cc pbruin added

comment:7 Changed 7 years ago by jdemeyer

  • Summary changed from Handle overflow in PARI -> CDF conversion to Handle errors in PARI -> CDF conversion

comment:8 Changed 7 years ago by pbruin

  • Reviewers set to Peter Bruin
  • Status changed from needs_review to positive_review

Looks like the right solution to me and passes doctests.

comment:9 Changed 7 years ago by vbraun

  • Branch changed from u/jdemeyer/ticket/17329 to ff6ddb1feb1d8760ef246ec6e20043911800d402
  • Resolution set to fixed
  • Status changed from positive_review to closed
Note: See TracTickets for help on using tickets.